%define anolis_release 13
%define debug_package %{nil}
%define QAT_release 00004

Summary: QAT package(Library and sample application)
Name: intel-QAT20
Version: L.0.9.4
Release: %{QAT_release}.%{anolis_release}%{dist}
Group: QAT/Base
License: BSD and (BSD or GPLv2)
Source: %{name}-%{version}-%{QAT_release}.tar.gz
Patch1000: 1000-bugfix-support-5.10.patch
Patch1001: 1001-bugfix-split-qat-vdcm-module.patch
Patch1002: 1002-bugfix-crash-of-rmmod-vdcm.patch
Patch1003: 1003-src-fix-warning-when-compiling.patch
Patch1004: 1004-build-split-kernel-space-and-user-space-building.patch
Patch1005: 1005-optimise-qat_service-scripts.patch
Patch1006: 1006-replace-usdm-with-udma.patch
Patch1007: 1007-Fix-uio-scan-logic.patch
Patch1008: 1008-modify-default-ServicesEnabled-to-asym-dc.patch

BuildRequires: gcc gcc-c++ make systemd-devel openssl-devel zlib-devel yasm
BuildRequires: udma-devel
BuildRequires: libudev-devel >= 1.47
BuildRequires: boost-devel

Requires(post): %{_sbindir}/depmod
Requires(post): pciutils
Requires(post): procps-ng

ExclusiveArch: x86_64

%description
Intel(R) QuickAssist Technology user space library and sample application Linux
version %{version}

%package devel
Summary:       Headers and libraries to build applications that use qatlib/OOT
Requires:      %{name} = %{version}-%{release}

%description devel
This package contains headers and libraries required to build applications
that use the Intel QuickAssist APIs.

%prep
%autosetup -c %{name}-%{version} -p1

%build
unset ICP_ROOT ICP_ARCH_USER ICP_BUILDSYSTEM_PATH ICP_BUILD_OUTPUT ICP_ENV_DIR ICP_TOOLS_TARGET
%configure

# make only work in single thread
make all-us

%pre
groupadd -f qat

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/udev/rules.d
mkdir -p %{buildroot}/%{_libdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/usr/bin/QAT
mkdir -p %{buildroot}/usr/bin/QAT/build
mkdir -p %{buildroot}/lib/firmware
MODPATH=drivers/crypto/qat
SRCMODDIR=${RPM_BUILD_DIR}/%{name}-%{version}/quickassist/qat/${MODPATH}

/usr/bin/install -D -m 750 quickassist/build_system/build_files/qat_service %{buildroot}/etc/init.d
/usr/bin/install -D -m 664 quickassist/build_system/build_files/qat.service %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 750 build/adf_ctl %{buildroot}%{_sbindir}
/usr/bin/install -D -m 750 build/vqat_ctl %{buildroot}%{_sbindir}
/usr/bin/install -D -m 755 build/libqat_s.so %{buildroot}/%{_libdir}

/usr/bin/install -D -m 666 build/4xxx_template.conf %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/4xxxvf_dev0.conf.vm %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.sym %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.asym %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.dc %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 755 config_vqat.sh %{buildroot}/usr/bin/QAT/
/usr/bin/install -D -m 755 generate_conf_files.sh %{buildroot}/usr/bin/QAT/

%{_bindir}/mv %{buildroot}/%{_libdir}/libqat_s.so %{buildroot}/%{_libdir}/libqat_s.so.%{version}
%{_bindir}/ln -sf %{_libdir}/libqat_s.so.%{version} %{buildroot}/%{_libdir}/libqat_s.so
%{_bindir}/ln -sf %{_libdir}/libqat_s.so.%{version} %{buildroot}/%{_libdir}/libqat_s.so.0

mkdir -p %{buildroot}/%{_includedir}/qat
%{_bindir}/find quickassist -name "*.h" | xargs tar cvf %{buildroot}/qat-headers.tgz
%{__tar} -xf %{buildroot}/qat-headers.tgz -C %{buildroot}/%{_includedir}/qat
%{__rm} -f %{buildroot}/qat-headers.tgz
mkdir -p %{buildroot}/%{_includedir}/qat/quickassist/lookaside/access_layer/src/common/crypto/kpt/crypto
/usr/bin/install -D -m 666 quickassist/lookaside/access_layer/src/common/crypto/kpt/crypto/lac_kpt_crypto_qat_comms.c %{buildroot}/%{_includedir}/qat/quickassist/lookaside/access_layer/src/common/crypto/kpt/crypto/lac_kpt_crypto_qat_comms.c

%clean
rm -rf $RPM_BUILD_ROOT

%verifyscript

%files
%license LICENSE.BSD
/etc/init.d/qat_service
%{_sbindir}/adf_ctl
%{_sbindir}/vqat_ctl
/usr/bin/QAT/
%{_libdir}/libqat_s.so.0
%{_libdir}/libqat_s.so.%{version}

%files devel
%license LICENSE.BSD
%{_includedir}/qat
%{_libdir}/libqat_s.so

%post
MV=/usr/bin/mv
ECHO=/usr/bin/echo
CP=/usr/bin/cp
SLEEP=/usr/bin/sleep
INSTALL=/usr/bin/install
ICP_ROOT=/usr/bin/QAT/
QAT_SERVICE_PATH=/etc/init.d/
HUGE_PAGE_DIR=/dev/hugepages/qat
SYSTEMD_SYSTEM_UNIT_DIR=`pkg-config --variable=systemdsystemunitdir systemd`
SYSTEMD_UNIT_FILE_PATH=${ICP_ROOT}/build
SYSTEMD_UNIT_FILE=qat.service
INTEL_VENDORID="8086"
QAT_4XXX_DEVICE_NUMBER="4940"
QAT_4XXX_DEVICE_NUMBER_VM="4941"
QAT_401XX_DEVICE_NUMBER="4942"
QAT_401XX_DEVICE_NUMBER_VM="4943"
QAT_402XX_DEVICE_NUMBER="4944"
QAT_402XX_DEVICE_NUMBER_VM="4945"
VQAT_DEVICE_NUMBER="0da5"
QAT_4XXX_NUM_VFS=16
DEVICES="${QAT_4XXX_DEVICE_NUMBER} ${QAT_4XXX_DEVICE_NUMBER_VM} ${QAT_401XX_DEVICE_NUMBER} ${QAT_401XX_DEVICE_NUMBER_VM} ${VQAT_DEVICE_NUMBER}"
num4xxxDevicesP=`lspci -n | grep -E -c "${INTEL_VENDORID}:${QAT_4XXX_DEVICE_NUMBER}"`
num4xxxDevicesV=`lspci -n | grep -E -c "${INTEL_VENDORID}:${QAT_4XXX_DEVICE_NUMBER_VM}"`
num401xxDevicesP=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_401XX_DEVICE_NUMBER}"`
num401xxDevicesV=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_401XX_DEVICE_NUMBER_VM}"`
num402xxDevicesP=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_402XX_DEVICE_NUMBER}"`
num402xxDevicesV=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_402XX_DEVICE_NUMBER_VM}"`
numVQATDevices=`lspci -n | grep -E -c "${INTEL_VENDORID}:${VQAT_DEVICE_NUMBER}"`

if [ -e ${QAT_SERVICE_PATH}/qat_service -a -e "/dev/qat_adf_ctl" ]; then
	until ${QAT_SERVICE_PATH}/qat_service shutdown
	do
		${SLEEP} 1
	done
fi
groupadd -f qat
if [ ! -d /etc/qat_conf_backup ]; then
	mkdir /etc/qat_conf_backup
fi
${MV} /etc/4xxx*.conf /etc/qat_conf_backup/ 2>/dev/null
${MV} /etc/4xxxvf*.conf /etc/qat_conf_backup/ 2>/dev/null
${MV} /etc/vqat*.conf /etc/qat_conf_backup/ 2>/dev/null

if [ "${num4xxxDevicesP}" -gt "0" ];then
	${ICP_ROOT}/generate_conf_files.sh -n ${num4xxxDevicesP} -f ${ICP_ROOT}/build/4xxx_template.conf -o /etc/
	if [ -e "/etc/default/qat" ];then
		. /etc/default/qat
		if [ -n "${SRIOV_ENABLE}" ];then
			if [ "${SRIOV_ENABLE}" -eq "1" ]; then
				num4xxxDevicesV=$((${QAT_4XXX_NUM_VFS} * ${num4xxxDevicesP}))
			fi
		fi
	else
		echo "#Remove comment on next line to enable sriov" > /etc/default/qat
		echo "#SRIOV_ENABLE=1" >> /etc/default/qat
	fi
fi

if [ "${num4xxxDevicesV}" -gt "0" ];then
	for (( dev=0; dev<${num4xxxDevicesV}; dev++ ));do
		${INSTALL} -D -m 640 ${ICP_ROOT}/build/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev${dev}.conf
	done
	echo "SRIOV_ENABLE=1" > /etc/default/qat
fi

if [ "${num401xxDevicesP}" -gt "0" ];then
    ${ICP_ROOT}/generate_conf_files.sh -n ${num401xxDevicesP} -f ${ICP_ROOT}/build/4xxx_template.conf -o /etc/
    if [ -e "/etc/default/qat" ];then
        . /etc/default/qat
        if [ -n "${SRIOV_ENABLE}" ];then
            if [ "${SRIOV_ENABLE}" -eq "1" ]; then
                num401xxDevicesV=$((${QAT_4XXX_NUM_VFS} * ${num401xxDevicesP}))
            fi
        fi
    else
        echo "#Remove comment on next line to enable sriov" > /etc/default/qat
        echo "#SRIOV_ENABLE=1" >> /etc/default/qat
    fi
fi

if [ "${num401xxDevicesV}" -gt "0" ];then
    for (( dev=0; dev<${num401xxDevicesV}; dev++ ));do
        ${INSTALL} -D -m 640 ${ICP_ROOT}/build/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev${dev}.conf
    done
    echo "SRIOV_ENABLE=1" > /etc/default/qat
fi

if [ "${num402xxDevicesP}" -gt "0" ];then
    ${ICP_ROOT}/generate_conf_files.sh -n ${num402xxDevicesP} -f ${ICP_ROOT}/build/4xxx_template.conf -o /etc/
    if [ -e "/etc/default/qat" ];then
        . /etc/default/qat
        if [ -n "${SRIOV_ENABLE}" ];then
            if [ "${SRIOV_ENABLE}" -eq "1" ]; then
                num402xxDevicesV=$((${QAT_4XXX_NUM_VFS} * ${num402xxDevicesP}))
            fi
        fi
    else
        echo "#Remove comment on next line to enable sriov" > /etc/default/qat
        echo "#SRIOV_ENABLE=1" >> /etc/default/qat
    fi
fi

if [ "${num402xxDevicesV}" -gt "0" ];then
    for (( dev=0; dev<${num402xxDevicesV}; dev++ ));do
        ${INSTALL} -D -m 640 ${ICP_ROOT}/build/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev${dev}.conf
    done
    echo "SRIOV_ENABLE=1" > /etc/default/qat
fi

if [ "${numVQATDevices}" -gt "0" ];then
	${ICP_ROOT}/config_vqat.sh
	echo "SRIOV_ENABLE=1" > /etc/default/qat
fi
mkdir -p /etc/udev/rules.d
echo 'KERNEL=="qat_adf_ctl" MODE="0660" GROUP="qat"' > /etc/udev/rules.d/00-qat.rules
echo 'KERNEL=="qat_dev_processes" MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
echo 'KERNEL=="usdm_drv" MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/mkdir' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/chgrp qat' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/chmod 0770' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="remove", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/rmdir' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
for dev in $DEVICES; do
	echo 'KERNEL=="uio*", ATTRS{vendor}=="0x'`echo ${INTEL_VENDORID} | tr -d \"`'", ATTRS{device}=="0x'`echo ${dev} | tr -d \"`'"  MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
done

if [ $(echo `uname -r` | grep -i tinyos) ]; then
	if [ -e ${QAT_SERVICE_PATH}/qat_service ]; then
		${ECHO} "Disable QAT service"
		systemctl disable qat
		systemctl daemon-reload
	fi
else
	if [ -e /usr/bin/systemctl ]; then
		if [ "${SYSTEMD_SYSTEM_UNIT_DIR}" == "" ]; then
			${ECHO} "Could not find path to place systemd unit file. Using /usr/lib/systemd/system by default"
		fi
		${CP} -f ${SYSTEMD_UNIT_FILE_PATH}/${SYSTEMD_UNIT_FILE} ${SYSTEMD_SYSTEM_UNIT_DIR}
		systemctl enable qat
		systemctl daemon-reload
	elif [ -e /sbin/chkconfig ] ; then
		chkconfig --add qat_service;
	elif [ -e %{_sbindir}/update-rc.d ]; then
		update-rc.d qat_service defaults
	fi

	${ECHO} "Starting QAT service"
	/etc/init.d/qat_service start
fi

%preun
QAT_SERVICE_PATH=/etc/init.d/
ECHO=/usr/bin/echo
RM=/usr/bin/rm
${ECHO} "Stopping QAT service"
if [ -e ${QAT_SERVICE_PATH}/qat_service ]; then
	until ${QAT_SERVICE_PATH}/qat_service shutdown
	do
		sleep 1
	done
	if [ -e /usr/bin/systemctl ]; then
		systemctl stop qat
		systemctl disable qat
		systemctl daemon-reload
	elif [ -e /sbin/chkconfig ]; then \
		chkconfig --del qat_service; \
	elif [ -e %{_sbindir}/update-rc.d ]; then \
		update-rc.d -f qat_service remove; \
	fi
fi
${RM} -rf /etc/udev/rules.d/00-qat.rules /etc/default/qat

%changelog
* Thu Mar 24 2025 Hao Xiang <hao.xiang@linux.alibaba.com> - 0.9.4-00004.13
- modify service enabled to asym;dc by default
- support gnr qat device id number 4944 & 4945 

* Thu Dec 14 2023 Xingrui Yi <yixingrui@linux.alibaba.com> - 0.9.4-00004.12
- Change qat_4xxx fw file path

* Thu Sep 14 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.11
- Add support for high-freq machine

* Thu Aug 10 2023 Kun(llfl) <llfl@linux.alibaba.com> - 0.9.4-00004.10
- Split build for user space only
- Update devel pkg

* Tue Nov 29 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.9
- Fix compiler warning

* Tue Nov 15 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.8
- Remove QAT driver

* Wed Nov 09 2022 Hao Xiang <hao.xiang@linux.alibaba.com> - 0.9.4-00004.7
- Get current kernel version by executing uname

* Tue Oct 25 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.6
- Fix kernel crash when rmmod qat_vdcm

* Fri Oct 21 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.5
- Stop QAT service in tinyos by default

* Tue Oct 18 2022 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.9.4-00004.4
- Fix bug in dc_sample_event_notif which leads to kernel crash

* Thu Oct 13 2022 Hao Xiang <hao.xiang@linux.alibaba.com> - 0.9.4-00004.3
- Split qat_vdcm module with qat_4xxx module

* Mon Sep 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.2
- Split kernel driver and library into separate packages

* Tue Aug 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.1
- Initial version of the package


